import pyloadl 
from sys import exit
from string import join

"""

   Displays information on the LoadLeveler cluster

"""

print "LoadLeveler version : %s" % pyloadl.ll_version()

query = pyloadl.ll_query(pyloadl.CLUSTERS)
if not pyloadl.PyCObjValid(query):
   print "ll_query(): returns NULL\n"
   exit(-1)

b = pyloadl.ll_set_request(query, pyloadl.QUERY_ALL, [""], pyloadl.ALL_DATA)
if b != 0:
   print  "ll_set_request(): error %d\n" % b
   exit(-1)

cluster, num, error = pyloadl.ll_get_objs(query, pyloadl.LL_CM, "")
if error != 0:
   print  "ll_get_objs(): error %d\n" % error
   exit(-1)

while pyloadl.PyCObjValid(cluster):

   schedtype = pyloadl.ll_get_data(cluster, pyloadl.LL_ClusterSchedulerType)
   print "Scheduler Type          : %s" %  schedtype

   enfsub = pyloadl.ll_get_data(cluster, pyloadl.LL_ClusterEnforceSubmission)
   print "Enforced Submission     : %s\n" % bool(enfsub)

   enfmem = pyloadl.ll_get_data(cluster, pyloadl.LL_ClusterEnforceMemory)
   print "Enforced Memory         : %s\n" % bool(enfmem)

   enfrescnt = pyloadl.ll_get_data(cluster, pyloadl.LL_ClusterEnforcedResourceCount)
   print "Enforced Resource Count : %d" % enfrescnt
   enfres = pyloadl.ll_get_data(cluster, pyloadl.LL_ClusterEnforcedResources)
   print "Enforced Resources      : %s\n" % join(enfres,", ")

   defrescnt = pyloadl.ll_get_data(cluster, pyloadl.LL_ClusterDefinedResourceCount)
   print "Defined Resource Count  : %d" % defrescnt
   defres = pyloadl.ll_get_data(cluster, pyloadl.LL_ClusterDefinedResources)
   print "Defined Resources       : %s\n" % join(defres,", ")

   schedrescnt = pyloadl.ll_get_data(cluster, pyloadl.LL_ClusterSchedulingResourceCount)
   print "Scheduled Resource Count: %d" % schedrescnt
   schedres = pyloadl.ll_get_data(cluster, pyloadl.LL_ClusterSchedulingResources)
   print "Scheduled Resources     : %s\n" % join(schedres,", ")

   print "Resource Info :\n"
   resource = pyloadl.ll_get_data(cluster, pyloadl.LL_ClusterGetFirstResource)
   while pyloadl.PyCObjValid(resource):

      name = pyloadl.ll_get_data(resource, pyloadl.LL_ResourceName)
      init_val = pyloadl.ll_get_data(resource, pyloadl.LL_ResourceInitialValue)
      avail_val = pyloadl.ll_get_data(resource, pyloadl.LL_ResourceAvailableValue)
      print "Name: %s, Inital : %d, Available : %d" % (name, init_val, avail_val)
      resource = pyloadl.ll_get_data(cluster, pyloadl.LL_ClusterGetNextResource)
    
   cluster = pyloadl.ll_next_obj(query)

#
# Free up space allocated by LoadLeveler
#

pyloadl.ll_free_objs(query)
pyloadl.ll_deallocate(query)
